package computer_factory;

import computer_factory.elements.*;
import computer_factory.visitor.ComputerPartDisplayVisitor;
import computer_factory.visitor.PriceVisitor;

public class Client {
    public static void main(String[] args) {
        Mouse mouse = new Mouse(50);
        Monitor monitor =  new Monitor(200);
        Keyboard keyboard = new Keyboard(200);
        Mainframe mainframe  = new Mainframe(1000);

        Computer computer = new Computer();

        computer.addPart(monitor);
        computer.addPart(mouse);
        computer.addPart(keyboard);
        computer.addPart(mainframe);

        System.out.println("Show all parts of the computer:");
        System.out.println("===============================");

        computer.accept(new ComputerPartDisplayVisitor());
        System.out.println();
        System.out.println("Show the price of  the computer:");
        System.out.println("================================");
        computer.accept(new PriceVisitor());


    }
}
