package computer_factory.elements;

import computer_factory.visitor.ComputerPartVisitor;

import java.util.ArrayList;
import java.util.List;

public class Computer implements ComputerPart {
    private List<ComputerPart> partsList;
    private int price;

    public Computer(){
        partsList = new ArrayList<>();
        price = 0;
    }

    public void addPart(ComputerPart part){
        partsList.add(part);
    }

    @Override
    public int getPrice() {
        return this.price;
    }

    public void setPrice(int price){
        this.price = price;
    }

    @Override
    public void accept(ComputerPartVisitor computerPartVisitor) {
        for (int i = 0; i < partsList.size(); i++) {
            partsList.get(i).accept(computerPartVisitor);
        }
        computerPartVisitor.visit(this);
    }
}
