package computer_factory.visitor;

import computer_factory.elements.*;

public class PriceVisitor implements ComputerPartVisitor {

    private int total_price;

    public PriceVisitor(){
        total_price = 0;
    }

    @Override
    public void visit(Computer computer) {
        computer.setPrice(total_price);
        System.out.println("The total price for this computer is "+total_price);
    }

    @Override
    public void visit(Mouse mouse) {
        System.out.println("The price of this mouse is "+mouse.getPrice());

        total_price+=mouse.getPrice();
    }

    @Override
    public void visit(Keyboard keyboard) {
        System.out.println("The price of this keyboard is "+keyboard.getPrice());
       total_price+=keyboard.getPrice();
    }

    @Override
    public void visit(Mainframe mainframe) {
        System.out.println("The price of this mainframe is "+mainframe.getPrice());

        total_price+=mainframe.getPrice();

    }

    @Override
    public void visit(Monitor monitor) {
        System.out.println("The price of this monitor is "+monitor.getPrice());

        total_price+=monitor.getPrice();
    }
}
